<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html lang="en">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>LCOV - report.info - /home/mila/Desktop/ProjekatRS/08-mainant/src/Node.cpp</title>
  <link rel="stylesheet" type="text/css" href="../../../../../../gcov.css">
</head>

<body>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="title">LCOV - code coverage report</td></tr>
    <tr><td class="ruler"><img src="../../../../../../glass.png" width=3 height=3 alt=""></td></tr>

    <tr>
      <td width="100%">
        <table cellpadding=1 border=0 width="100%">
          <tr>
            <td width="10%" class="headerItem">Current view:</td>
            <td width="35%" class="headerValue"><a href="../../../../../../index.html">top level</a> - <a href="index.html">home/mila/Desktop/ProjekatRS/08-mainant/src</a> - Node.cpp<span style="font-size: 80%;"> (source / <a href="Node.cpp.func-sort-c.html">functions</a>)</span></td>
            <td width="5%"></td>
            <td width="15%"></td>
            <td width="10%" class="headerCovTableHead">Hit</td>
            <td width="10%" class="headerCovTableHead">Total</td>
            <td width="15%" class="headerCovTableHead">Coverage</td>
          </tr>
          <tr>
            <td class="headerItem">Test:</td>
            <td class="headerValue">report.info</td>
            <td></td>
            <td class="headerItem">Lines:</td>
            <td class="headerCovTableEntry">84</td>
            <td class="headerCovTableEntry">249</td>
            <td class="headerCovTableEntryLo">33.7 %</td>
          </tr>
          <tr>
            <td class="headerItem">Date:</td>
            <td class="headerValue">2021-03-29 02:25:54</td>
            <td></td>
            <td class="headerItem">Functions:</td>
            <td class="headerCovTableEntry">8</td>
            <td class="headerCovTableEntry">28</td>
            <td class="headerCovTableEntryLo">28.6 %</td>
          </tr>
          <tr><td><img src="../../../../../../glass.png" width=3 height=3 alt=""></td></tr>
        </table>
      </td>
    </tr>

    <tr><td class="ruler"><img src="../../../../../../glass.png" width=3 height=3 alt=""></td></tr>
  </table>

  <table cellpadding=0 cellspacing=0 border=0>
    <tr>
      <td><br></td>
    </tr>
    <tr>
      <td>
<pre class="sourceHeading">          Line data    Source code</pre>
<pre class="source">
<a name="1"><span class="lineNum">       1 </span>            : #include &quot;./headers/Node.h&quot;</a>
<a name="2"><span class="lineNum">       2 </span>            : </a>
<a name="3"><span class="lineNum">       3 </span><span class="lineCov">          2 : Node::Node(QWidget *parent) : QFrame(parent) {</span></a>
<a name="4"><span class="lineNum">       4 </span><span class="lineCov">          2 :   setMaximumSize(150, 150);</span></a>
<a name="5"><span class="lineNum">       5 </span><span class="lineCov">          2 :   setStyleSheet(&quot;background-color: rgba(24, 135, 127, 1);&quot;</span></a>
<a name="6"><span class="lineNum">       6 </span>            :                 &quot;border: 1px solid rgba(205, 221, 63, 1);&quot;</a>
<a name="7"><span class="lineNum">       7 </span>            :                 &quot;border-radius: 5px;&quot;);</a>
<a name="8"><span class="lineNum">       8 </span><span class="lineCov">          2 :   this-&gt;setLayout(new QGridLayout());</span></a>
<a name="9"><span class="lineNum">       9 </span><span class="lineCov">          2 :   *(this-&gt;getOldPos()) = this-&gt;pos();</span></a>
<a name="10"><span class="lineNum">      10 </span><span class="lineCov">          2 :   colors['i'] = &quot;border-width: 2px;border-color: rgba(0, 194, 255, &quot;</span></a>
<a name="11"><span class="lineNum">      11 </span><span class="lineCov">          2 :                 &quot;1);border-radius: 10px;&quot;; // int long</span></a>
<a name="12"><span class="lineNum">      12 </span><span class="lineCov">          2 :   colors['n'] = &quot;border-width: 2px;border-color: rgba(173, 91, 219, &quot;</span></a>
<a name="13"><span class="lineNum">      13 </span><span class="lineCov">          2 :                 &quot;1);border-radius: 10px;&quot;; // broj</span></a>
<a name="14"><span class="lineNum">      14 </span><span class="lineCov">          2 :   colors['f'] = &quot;border-width: 2px;border-color: rgba(141, 233, 50, &quot;</span></a>
<a name="15"><span class="lineNum">      15 </span><span class="lineCov">          2 :                 &quot;1);border-radius: 10px;&quot;; // float double</span></a>
<a name="16"><span class="lineNum">      16 </span><span class="lineCov">          2 :   colors['b'] = &quot;border-width: 2px;border-color: rgba(255, 2, 116, &quot;</span></a>
<a name="17"><span class="lineNum">      17 </span><span class="lineCov">          2 :                 &quot;1);border-radius: 10px;&quot;; // bool</span></a>
<a name="18"><span class="lineNum">      18 </span><span class="lineCov">          2 :   colors['s'] = &quot;border-width: 2px;border-color: rgba(255, 156, 57, &quot;</span></a>
<a name="19"><span class="lineNum">      19 </span><span class="lineCov">          2 :                 &quot;1);border-radius: 10px;&quot;; // string</span></a>
<a name="20"><span class="lineNum">      20 </span><span class="lineCov">          2 :   colors['c'] = &quot;border-width: 2px;border-color: rgba(255, 104, 107, &quot;</span></a>
<a name="21"><span class="lineNum">      21 </span><span class="lineCov">          2 :                 &quot;1);border-radius: 10px;&quot;; // char</span></a>
<a name="22"><span class="lineNum">      22 </span><span class="lineCov">          2 :   colors['q'] = &quot;border-width: 2px;border-color: rgba(65, 247, 201, &quot;</span></a>
<a name="23"><span class="lineNum">      23 </span>            :                 &quot;1);border-top-right-radius: 10px;border-bottom-right-radius: &quot;</a>
<a name="24"><span class="lineNum">      24 </span><span class="lineCov">          2 :                 &quot;10px;&quot;; // kontrola toka</span></a>
<a name="25"><span class="lineNum">      25 </span><span class="lineCov">          2 :   colors['v'] = &quot;border-width: 2px;border-color: rgba(0, 0, 0, &quot;</span></a>
<a name="26"><span class="lineNum">      26 </span><span class="lineCov">          2 :                 &quot;1);border-radius: 10px;&quot;; // int long</span></a>
<a name="27"><span class="lineNum">      27 </span><span class="lineCov">          2 : }</span></a>
<a name="28"><span class="lineNum">      28 </span>            : </a>
<a name="29"><span class="lineNum">      29 </span><span class="lineCov">          2 : Node::Node(QString _name, int ninputs, int noutputs, QVector&lt;QString&gt; _args,</span></a>
<a name="30"><span class="lineNum">      30 </span><span class="lineCov">          2 :            QString code, QWidget *parent)</span></a>
<a name="31"><span class="lineNum">      31 </span><span class="lineCov">          2 :     : Node(parent) {</span></a>
<a name="32"><span class="lineNum">      32 </span><span class="lineCov">          2 :   funcRef = false;</span></a>
<a name="33"><span class="lineNum">      33 </span><span class="lineCov">          2 :   ClassInstance = false;</span></a>
<a name="34"><span class="lineNum">      34 </span><span class="lineCov">          2 :   methodNode = false;</span></a>
<a name="35"><span class="lineNum">      35 </span><span class="lineCov">          2 :   auto *layout = static_cast&lt;QGridLayout *&gt;(this-&gt;layout());</span></a>
<a name="36"><span class="lineNum">      36 </span><span class="lineCov">          2 :   layout-&gt;setHorizontalSpacing(2);</span></a>
<a name="37"><span class="lineNum">      37 </span><span class="lineCov">          2 :   layout-&gt;setVerticalSpacing(5);</span></a>
<a name="38"><span class="lineNum">      38 </span><span class="lineCov">          2 :   this-&gt;code = code;</span></a>
<a name="39"><span class="lineNum">      39 </span><span class="lineCov">          3 :   this-&gt;setMaximumSize(150, ninputs &gt; noutputs ? 27 * (ninputs + 1)</span></a>
<a name="40"><span class="lineNum">      40 </span><span class="lineCov">          1 :                                                : 27 * (noutputs + 1));</span></a>
<a name="41"><span class="lineNum">      41 </span><span class="lineCov">          2 :   this-&gt;name = _name;</span></a>
<a name="42"><span class="lineNum">      42 </span><span class="lineCov">          2 :   this-&gt;nameLbl = new QLabel(name);</span></a>
<a name="43"><span class="lineNum">      43 </span><span class="lineCov">          2 :   if (_args.length() == 0) {</span></a>
<a name="44"><span class="lineNum">      44 </span><span class="lineCov">          2 :     _args.resize(ninputs == 0 ? 1 : ninputs);</span></a>
<a name="45"><span class="lineNum">      45 </span><span class="lineCov">          3 :     for (int i = 0; i &lt; ninputs; i++)</span></a>
<a name="46"><span class="lineNum">      46 </span><span class="lineCov">          1 :       _args[i] = &quot;&quot;;</span></a>
<a name="47"><span class="lineNum">      47 </span>            :   }</a>
<a name="48"><span class="lineNum">      48 </span>            : </a>
<a name="49"><span class="lineNum">      49 </span><span class="lineCov">          2 :   this-&gt;nameLbl-&gt;setMaximumSize(100, 20);</span></a>
<a name="50"><span class="lineNum">      50 </span><span class="lineCov">          2 :   layout-&gt;addWidget(nameLbl, 0, 0, 1, 3);</span></a>
<a name="51"><span class="lineNum">      51 </span><span class="lineCov">          4 :   QFont f(&quot;Arial&quot;, 6);</span></a>
<a name="52"><span class="lineNum">      52 </span><span class="lineCov">          2 :   int n = 0;</span></a>
<a name="53"><span class="lineNum">      53 </span><span class="lineCov">          2 :   for (int i = 0; i &lt; std::min(ninputs, noutputs); i++, n++) {</span></a>
<a name="54"><span class="lineNum">      54 </span>            : </a>
<a name="55"><span class="lineNum">      55 </span><span class="lineNoCov">          0 :     auto *o = new Output();</span></a>
<a name="56"><span class="lineNum">      56 </span><span class="lineNoCov">          0 :     auto *tmp = new Input();</span></a>
<a name="57"><span class="lineNum">      57 </span><span class="lineNoCov">          0 :     layout-&gt;addWidget(tmp, i + 1, 0);</span></a>
<a name="58"><span class="lineNum">      58 </span><span class="lineNoCov">          0 :     layout-&gt;addWidget(o, i + 1, 3);</span></a>
<a name="59"><span class="lineNum">      59 </span><span class="lineNoCov">          0 :     this-&gt;inputs.push_back(tmp);</span></a>
<a name="60"><span class="lineNum">      60 </span><span class="lineNoCov">          0 :     this-&gt;outputs.push_back(o);</span></a>
<a name="61"><span class="lineNum">      61 </span>            : </a>
<a name="62"><span class="lineNum">      62 </span><span class="lineNoCov">          0 :     if (_args[i].compare(&quot;&quot;) != 0) {</span></a>
<a name="63"><span class="lineNum">      63 </span><span class="lineNoCov">          0 :       auto *lbl = new QLabel(_args[i]);</span></a>
<a name="64"><span class="lineNum">      64 </span><span class="lineNoCov">          0 :       lbl-&gt;setFixedSize(40, 20);</span></a>
<a name="65"><span class="lineNum">      65 </span><span class="lineNoCov">          0 :       lbl-&gt;setFont(f);</span></a>
<a name="66"><span class="lineNum">      66 </span><span class="lineNoCov">          0 :       auto *txt = new QTextEdit();</span></a>
<a name="67"><span class="lineNum">      67 </span><span class="lineNoCov">          0 :       txt-&gt;setFixedSize(40, 20);</span></a>
<a name="68"><span class="lineNum">      68 </span><span class="lineNoCov">          0 :       txt-&gt;setFontPointSize(6);</span></a>
<a name="69"><span class="lineNum">      69 </span><span class="lineNoCov">          0 :       layout-&gt;addWidget(lbl, i + 1, 1, 1, 1);</span></a>
<a name="70"><span class="lineNum">      70 </span><span class="lineNoCov">          0 :       layout-&gt;addWidget(txt, i + 1, 2, 1, 1);</span></a>
<a name="71"><span class="lineNum">      71 </span><span class="lineNoCov">          0 :       this-&gt;args.push_back(txt);</span></a>
<a name="72"><span class="lineNum">      72 </span>            :     } else {</a>
<a name="73"><span class="lineNum">      73 </span><span class="lineNoCov">          0 :       auto *txt = new QTextEdit();</span></a>
<a name="74"><span class="lineNum">      74 </span><span class="lineNoCov">          0 :       txt-&gt;setFixedSize(40, 20);</span></a>
<a name="75"><span class="lineNum">      75 </span><span class="lineNoCov">          0 :       txt-&gt;setFontPointSize(6);</span></a>
<a name="76"><span class="lineNum">      76 </span><span class="lineNoCov">          0 :       layout-&gt;addWidget(txt, i + 1, 1);</span></a>
<a name="77"><span class="lineNum">      77 </span><span class="lineNoCov">          0 :       this-&gt;args.push_back(txt);</span></a>
<a name="78"><span class="lineNum">      78 </span>            :     }</a>
<a name="79"><span class="lineNum">      79 </span>            :   }</a>
<a name="80"><span class="lineNum">      80 </span><span class="lineCov">          4 :   for (int i = n; i &lt; std::max(ninputs, noutputs); i++) {</span></a>
<a name="81"><span class="lineNum">      81 </span><span class="lineCov">          2 :     if (ninputs == noutputs) {</span></a>
<a name="82"><span class="lineNum">      82 </span><span class="lineNoCov">          0 :       auto *o = new Output();</span></a>
<a name="83"><span class="lineNum">      83 </span><span class="lineNoCov">          0 :       auto *tmp = new Input();</span></a>
<a name="84"><span class="lineNum">      84 </span><span class="lineNoCov">          0 :       layout-&gt;addWidget(tmp, i + 1, 0);</span></a>
<a name="85"><span class="lineNum">      85 </span><span class="lineNoCov">          0 :       layout-&gt;addWidget(o, i + 1, 3);</span></a>
<a name="86"><span class="lineNum">      86 </span><span class="lineNoCov">          0 :       this-&gt;inputs.push_back(tmp);</span></a>
<a name="87"><span class="lineNum">      87 </span><span class="lineNoCov">          0 :       this-&gt;outputs.push_back(o);</span></a>
<a name="88"><span class="lineNum">      88 </span>            : </a>
<a name="89"><span class="lineNum">      89 </span><span class="lineNoCov">          0 :       if (_args[i].compare(&quot;&quot;) != 0) {</span></a>
<a name="90"><span class="lineNum">      90 </span><span class="lineNoCov">          0 :         auto *lbl = new QLabel(_args[i]);</span></a>
<a name="91"><span class="lineNum">      91 </span><span class="lineNoCov">          0 :         lbl-&gt;setFixedSize(40, 20);</span></a>
<a name="92"><span class="lineNum">      92 </span><span class="lineNoCov">          0 :         lbl-&gt;setFont(f);</span></a>
<a name="93"><span class="lineNum">      93 </span><span class="lineNoCov">          0 :         auto *txt = new QTextEdit();</span></a>
<a name="94"><span class="lineNum">      94 </span><span class="lineNoCov">          0 :         txt-&gt;setFontPointSize(6);</span></a>
<a name="95"><span class="lineNum">      95 </span><span class="lineNoCov">          0 :         txt-&gt;setFixedSize(40, 20);</span></a>
<a name="96"><span class="lineNum">      96 </span><span class="lineNoCov">          0 :         layout-&gt;addWidget(lbl, i + 1, 1, 1, 1);</span></a>
<a name="97"><span class="lineNum">      97 </span><span class="lineNoCov">          0 :         layout-&gt;addWidget(txt, i + 1, 2, 1, 1);</span></a>
<a name="98"><span class="lineNum">      98 </span><span class="lineNoCov">          0 :         this-&gt;args.push_back(txt);</span></a>
<a name="99"><span class="lineNum">      99 </span>            :       } else {</a>
<a name="100"><span class="lineNum">     100 </span><span class="lineNoCov">          0 :         auto *txt = new QTextEdit();</span></a>
<a name="101"><span class="lineNum">     101 </span><span class="lineNoCov">          0 :         txt-&gt;setFixedSize(40, 20);</span></a>
<a name="102"><span class="lineNum">     102 </span><span class="lineNoCov">          0 :         txt-&gt;setFontPointSize(6);</span></a>
<a name="103"><span class="lineNum">     103 </span><span class="lineNoCov">          0 :         layout-&gt;addWidget(txt, i + 1, 1);</span></a>
<a name="104"><span class="lineNum">     104 </span><span class="lineNoCov">          0 :         this-&gt;args.push_back(txt);</span></a>
<a name="105"><span class="lineNum">     105 </span>            :       }</a>
<a name="106"><span class="lineNum">     106 </span><span class="lineNoCov">          0 :       continue;</span></a>
<a name="107"><span class="lineNum">     107 </span>            :     }</a>
<a name="108"><span class="lineNum">     108 </span>            : </a>
<a name="109"><span class="lineNum">     109 </span><span class="lineCov">          2 :     if (noutputs &gt; ninputs) {</span></a>
<a name="110"><span class="lineNum">     110 </span><span class="lineCov">          1 :       auto *tmp = new Output();</span></a>
<a name="111"><span class="lineNum">     111 </span><span class="lineCov">          1 :       this-&gt;outputs.push_back(tmp);</span></a>
<a name="112"><span class="lineNum">     112 </span><span class="lineCov">          1 :       layout-&gt;addWidget(tmp, i + 1, 3);</span></a>
<a name="113"><span class="lineNum">     113 </span><span class="lineCov">          1 :       continue;</span></a>
<a name="114"><span class="lineNum">     114 </span>            :     }</a>
<a name="115"><span class="lineNum">     115 </span><span class="lineCov">          1 :     if (ninputs &gt; noutputs) {</span></a>
<a name="116"><span class="lineNum">     116 </span><span class="lineCov">          1 :       auto *tmp = new Input();</span></a>
<a name="117"><span class="lineNum">     117 </span><span class="lineCov">          1 :       layout-&gt;addWidget(tmp, i + 1, 0);</span></a>
<a name="118"><span class="lineNum">     118 </span><span class="lineCov">          1 :       this-&gt;inputs.push_back(tmp);</span></a>
<a name="119"><span class="lineNum">     119 </span>            : </a>
<a name="120"><span class="lineNum">     120 </span><span class="lineCov">          1 :       if (_args[i].compare(&quot;&quot;) != 0) {</span></a>
<a name="121"><span class="lineNum">     121 </span><span class="lineNoCov">          0 :         auto *lbl = new QLabel(_args[i]);</span></a>
<a name="122"><span class="lineNum">     122 </span><span class="lineNoCov">          0 :         lbl-&gt;setFixedSize(40, 20);</span></a>
<a name="123"><span class="lineNum">     123 </span><span class="lineNoCov">          0 :         lbl-&gt;setFont(f);</span></a>
<a name="124"><span class="lineNum">     124 </span><span class="lineNoCov">          0 :         auto *txt = new QTextEdit();</span></a>
<a name="125"><span class="lineNum">     125 </span><span class="lineNoCov">          0 :         txt-&gt;setFixedSize(40, 20);</span></a>
<a name="126"><span class="lineNum">     126 </span><span class="lineNoCov">          0 :         txt-&gt;setFontPointSize(6);</span></a>
<a name="127"><span class="lineNum">     127 </span><span class="lineNoCov">          0 :         layout-&gt;addWidget(lbl, i + 1, 1, 1, 1);</span></a>
<a name="128"><span class="lineNum">     128 </span><span class="lineNoCov">          0 :         layout-&gt;addWidget(txt, i + 1, 2, 1, 1);</span></a>
<a name="129"><span class="lineNum">     129 </span><span class="lineNoCov">          0 :         this-&gt;args.push_back(txt);</span></a>
<a name="130"><span class="lineNum">     130 </span>            :       } else {</a>
<a name="131"><span class="lineNum">     131 </span><span class="lineCov">          1 :         auto *txt = new QTextEdit();</span></a>
<a name="132"><span class="lineNum">     132 </span><span class="lineCov">          1 :         txt-&gt;setFixedSize(40, 20);</span></a>
<a name="133"><span class="lineNum">     133 </span><span class="lineCov">          1 :         txt-&gt;setFontPointSize(6);</span></a>
<a name="134"><span class="lineNum">     134 </span><span class="lineCov">          1 :         layout-&gt;addWidget(txt, i + 1, 1);</span></a>
<a name="135"><span class="lineNum">     135 </span><span class="lineCov">          1 :         this-&gt;args.push_back(txt);</span></a>
<a name="136"><span class="lineNum">     136 </span>            :       }</a>
<a name="137"><span class="lineNum">     137 </span>            :     }</a>
<a name="138"><span class="lineNum">     138 </span>            :   }</a>
<a name="139"><span class="lineNum">     139 </span><span class="lineCov">          2 : }</span></a>
<a name="140"><span class="lineNum">     140 </span>            : </a>
<a name="141"><span class="lineNum">     141 </span><span class="lineNoCov">          0 : void Node::mouseMoveEvent(QMouseEvent *event) {</span></a>
<a name="142"><span class="lineNum">     142 </span><span class="lineNoCov">          0 :   if (childAt(event-&gt;pos()) == nullptr) {</span></a>
<a name="143"><span class="lineNum">     143 </span><span class="lineNoCov">          0 :     this-&gt;move(mapToParent(event-&gt;pos() - offset));</span></a>
<a name="144"><span class="lineNum">     144 </span>            :   } else {</a>
<a name="145"><span class="lineNum">     145 </span><span class="lineNoCov">          0 :     QFrame::mouseMoveEvent(event);</span></a>
<a name="146"><span class="lineNum">     146 </span>            :   }</a>
<a name="147"><span class="lineNum">     147 </span><span class="lineNoCov">          0 :   this-&gt;oldPos_ = this-&gt;pos();</span></a>
<a name="148"><span class="lineNum">     148 </span><span class="lineNoCov">          0 : }</span></a>
<a name="149"><span class="lineNum">     149 </span>            : </a>
<a name="150"><span class="lineNum">     150 </span><span class="lineNoCov">          0 : void Node::deleteNodeInParentSlot(QString nodeId) {</span></a>
<a name="151"><span class="lineNum">     151 </span><span class="lineNoCov">          0 :   int i = 0;</span></a>
<a name="152"><span class="lineNum">     152 </span><span class="lineNoCov">          0 :   for (auto childrenOfNode : this-&gt;childNodes) {</span></a>
<a name="153"><span class="lineNum">     153 </span><span class="lineNoCov">          0 :     if (childrenOfNode-&gt;nodeId == nodeId) {</span></a>
<a name="154"><span class="lineNum">     154 </span><span class="lineNoCov">          0 :       this-&gt;childNodes.remove(i);</span></a>
<a name="155"><span class="lineNum">     155 </span>            :     }</a>
<a name="156"><span class="lineNum">     156 </span><span class="lineNoCov">          0 :     i++;</span></a>
<a name="157"><span class="lineNum">     157 </span>            :   }</a>
<a name="158"><span class="lineNum">     158 </span><span class="lineNoCov">          0 : }</span></a>
<a name="159"><span class="lineNum">     159 </span>            : </a>
<a name="160"><span class="lineNum">     160 </span><span class="lineNoCov">          0 : void Node::mousePressEvent(QMouseEvent *event) {</span></a>
<a name="161"><span class="lineNum">     161 </span><span class="lineNoCov">          0 :   offset = event-&gt;pos();</span></a>
<a name="162"><span class="lineNum">     162 </span><span class="lineNoCov">          0 :   if (event-&gt;button() == Qt::RightButton) {</span></a>
<a name="163"><span class="lineNum">     163 </span><span class="lineNoCov">          0 :     QPoint globalPos = this-&gt;mapToGlobal(event-&gt;pos());</span></a>
<a name="164"><span class="lineNum">     164 </span><span class="lineNoCov">          0 :     QMenu myMenu;</span></a>
<a name="165"><span class="lineNum">     165 </span><span class="lineNoCov">          0 :     myMenu.addAction(&quot;Delete&quot;);</span></a>
<a name="166"><span class="lineNum">     166 </span><span class="lineNoCov">          0 :     if (!this-&gt;hiddingSomething) {</span></a>
<a name="167"><span class="lineNum">     167 </span><span class="lineNoCov">          0 :       myMenu.addAction(&quot;Hide&quot;);</span></a>
<a name="168"><span class="lineNum">     168 </span>            :     }</a>
<a name="169"><span class="lineNum">     169 </span><span class="lineNoCov">          0 :     if (this-&gt;hiddingSomething) {</span></a>
<a name="170"><span class="lineNum">     170 </span><span class="lineNoCov">          0 :       myMenu.addAction(&quot;Show&quot;);</span></a>
<a name="171"><span class="lineNum">     171 </span>            :     }</a>
<a name="172"><span class="lineNum">     172 </span><span class="lineNoCov">          0 :     QAction *selectedItem = myMenu.exec(globalPos);</span></a>
<a name="173"><span class="lineNum">     173 </span>            : </a>
<a name="174"><span class="lineNum">     174 </span><span class="lineNoCov">          0 :     if (selectedItem) {</span></a>
<a name="175"><span class="lineNum">     175 </span><span class="lineNoCov">          0 :       if (selectedItem-&gt;toolTip() == &quot;Delete&quot;) {</span></a>
<a name="176"><span class="lineNum">     176 </span><span class="lineNoCov">          0 :         if (this-&gt;name == &quot;Class&quot; || this-&gt;name == &quot;Method&quot; ||</span></a>
<a name="177"><span class="lineNum">     177 </span><span class="lineNoCov">          0 :             this-&gt;name == &quot;Function&quot; || this-&gt;name == &quot;FunctionReturn&quot;) {</span></a>
<a name="178"><span class="lineNum">     178 </span><span class="lineNoCov">          0 :           QMessageBox msgBox;</span></a>
<a name="179"><span class="lineNum">     179 </span><span class="lineNoCov">          0 :           msgBox.setText(&quot;You can't delete &quot; + this-&gt;name + &quot;Node.&quot;);</span></a>
<a name="180"><span class="lineNum">     180 </span><span class="lineNoCov">          0 :           msgBox.exec();</span></a>
<a name="181"><span class="lineNum">     181 </span>            :         } else {</a>
<a name="182"><span class="lineNum">     182 </span>            :           // qDebug()&lt;&lt;&quot;Delete&quot;;</a>
<a name="183"><span class="lineNum">     183 </span><span class="lineNoCov">          0 :           this-&gt;close();</span></a>
<a name="184"><span class="lineNum">     184 </span><span class="lineNoCov">          0 :           this-&gt;exist = false;</span></a>
<a name="185"><span class="lineNum">     185 </span>            :           auto parentMainWindow =</a>
<a name="186"><span class="lineNum">     186 </span><span class="lineNoCov">          0 :               qobject_cast&lt;QMainWindow *&gt;(this-&gt;parent()-&gt;parent()-&gt;parent());</span></a>
<a name="187"><span class="lineNum">     187 </span><span class="lineNoCov">          0 :           connect(this, SIGNAL(deletedReferencedNode(QString)),</span></a>
<a name="188"><span class="lineNum">     188 </span>            :                   parentMainWindow, SLOT(onDeletedReferencedNode(QString)));</a>
<a name="189"><span class="lineNum">     189 </span><span class="lineNoCov">          0 :           if (this-&gt;name == &quot;var&quot; || this-&gt;name == &quot;vector&quot; ||</span></a>
<a name="190"><span class="lineNum">     190 </span><span class="lineNoCov">          0 :               this-&gt;name == &quot;stack&quot; || this-&gt;name == &quot;queue&quot; ||</span></a>
<a name="191"><span class="lineNum">     191 </span><span class="lineNoCov">          0 :               this-&gt;name == &quot;map&quot;) {</span></a>
<a name="192"><span class="lineNum">     192 </span><span class="lineNoCov">          0 :             emit deletedReferencedNode(this-&gt;nodeId);</span></a>
<a name="193"><span class="lineNum">     193 </span>            :           }</a>
<a name="194"><span class="lineNum">     194 </span><span class="lineNoCov">          0 :           connect(this, SIGNAL(deletedStartNode(Node *)), parentMainWindow,</span></a>
<a name="195"><span class="lineNum">     195 </span>            :                   SLOT(onDeletedStartNode(Node *)));</a>
<a name="196"><span class="lineNum">     196 </span><span class="lineNoCov">          0 :           if (this-&gt;name == &quot;StartNode&quot;) {</span></a>
<a name="197"><span class="lineNum">     197 </span><span class="lineNoCov">          0 :             emit deletedStartNode(this);</span></a>
<a name="198"><span class="lineNum">     198 </span>            :           }</a>
<a name="199"><span class="lineNum">     199 </span><span class="lineNoCov">          0 :           this-&gt;destroy();</span></a>
<a name="200"><span class="lineNum">     200 </span>            :         }</a>
<a name="201"><span class="lineNum">     201 </span><span class="lineNoCov">          0 :         for (auto parentOfNode : this-&gt;parentNodes) {</span></a>
<a name="202"><span class="lineNum">     202 </span><span class="lineNoCov">          0 :           connect(this, SIGNAL(deleteNodeInParentSignal(QString)), parentOfNode,</span></a>
<a name="203"><span class="lineNum">     203 </span>            :                   SLOT(deleteNodeInParentSlot(QString)));</a>
<a name="204"><span class="lineNum">     204 </span><span class="lineNoCov">          0 :           emit(deleteNodeInParentSignal(this-&gt;nodeId));</span></a>
<a name="205"><span class="lineNum">     205 </span>            :         }</a>
<a name="206"><span class="lineNum">     206 </span><span class="lineNoCov">          0 :       } else if (selectedItem-&gt;toolTip() == &quot;Hide&quot;) {</span></a>
<a name="207"><span class="lineNum">     207 </span>            :         // qDebug()&lt;&lt; &quot;Hide&quot;;</a>
<a name="208"><span class="lineNum">     208 </span><span class="lineNoCov">          0 :         if (!this-&gt;parentNodes.empty()) {</span></a>
<a name="209"><span class="lineNum">     209 </span><span class="lineNoCov">          0 :           this-&gt;hiddingSomething = true;</span></a>
<a name="210"><span class="lineNum">     210 </span><span class="lineNoCov">          0 :           Node *node = this;</span></a>
<a name="211"><span class="lineNum">     211 </span><span class="lineNoCov">          0 :           std::stack&lt;Node *&gt; stek;</span></a>
<a name="212"><span class="lineNum">     212 </span><span class="lineNoCov">          0 :           bool begining = true;</span></a>
<a name="213"><span class="lineNum">     213 </span><span class="lineNoCov">          0 :           while (!node-&gt;parentNodes.empty() || !stek.empty() ||</span></a>
<a name="214"><span class="lineNum">     214 </span><span class="lineNoCov">          0 :                  begining == true) {</span></a>
<a name="215"><span class="lineNum">     215 </span><span class="lineNoCov">          0 :             begining = false;</span></a>
<a name="216"><span class="lineNum">     216 </span><span class="lineNoCov">          0 :             int childNum = node-&gt;parentNodes.size();</span></a>
<a name="217"><span class="lineNum">     217 </span><span class="lineNoCov">          0 :             int i = 0;</span></a>
<a name="218"><span class="lineNum">     218 </span><span class="lineNoCov">          0 :             for (; i &lt; childNum; i++) {</span></a>
<a name="219"><span class="lineNum">     219 </span>            : </a>
<a name="220"><span class="lineNum">     220 </span><span class="lineNoCov">          0 :               if (node-&gt;parentNodes[i]-&gt;getVisitedHide() == false) {</span></a>
<a name="221"><span class="lineNum">     221 </span><span class="lineNoCov">          0 :                 node-&gt;parentNodes[i]-&gt;setVisitedHide(true);</span></a>
<a name="222"><span class="lineNum">     222 </span><span class="lineNoCov">          0 :                 node-&gt;parentNodes[i]-&gt;isHidden = true;</span></a>
<a name="223"><span class="lineNum">     223 </span><span class="lineNoCov">          0 :                 node-&gt;parentNodes[i]-&gt;hide();</span></a>
<a name="224"><span class="lineNum">     224 </span><span class="lineNoCov">          0 :                 stek.push(node-&gt;parentNodes[i]);</span></a>
<a name="225"><span class="lineNum">     225 </span>            :               }</a>
<a name="226"><span class="lineNum">     226 </span>            :             }</a>
<a name="227"><span class="lineNum">     227 </span><span class="lineNoCov">          0 :             node = stek.top();</span></a>
<a name="228"><span class="lineNum">     228 </span><span class="lineNoCov">          0 :             stek.pop();</span></a>
<a name="229"><span class="lineNum">     229 </span><span class="lineNoCov">          0 :             node-&gt;setVisitedHide(false);</span></a>
<a name="230"><span class="lineNum">     230 </span><span class="lineNoCov">          0 :             node-&gt;hide();</span></a>
<a name="231"><span class="lineNum">     231 </span>            :           }</a>
<a name="232"><span class="lineNum">     232 </span><span class="lineNoCov">          0 :           auto *bodyShadow = new QGraphicsDropShadowEffect;</span></a>
<a name="233"><span class="lineNum">     233 </span><span class="lineNoCov">          0 :           bodyShadow-&gt;setBlurRadius(13.0);</span></a>
<a name="234"><span class="lineNum">     234 </span>            :           // QColor color=this-&gt;palette().color(backgroundRole());</a>
<a name="235"><span class="lineNum">     235 </span><span class="lineNoCov">          0 :           bodyShadow-&gt;setColor(this-&gt;palette().Dark);</span></a>
<a name="236"><span class="lineNum">     236 </span><span class="lineNoCov">          0 :           bodyShadow-&gt;setOffset(8.0);</span></a>
<a name="237"><span class="lineNum">     237 </span><span class="lineNoCov">          0 :           this-&gt;setGraphicsEffect(bodyShadow);</span></a>
<a name="238"><span class="lineNum">     238 </span>            :         }</a>
<a name="239"><span class="lineNum">     239 </span><span class="lineNoCov">          0 :       } else if (selectedItem-&gt;toolTip() == &quot;Show&quot;) {</span></a>
<a name="240"><span class="lineNum">     240 </span>            :         // qDebug()&lt;&lt; &quot;Show&quot;;</a>
<a name="241"><span class="lineNum">     241 </span><span class="lineNoCov">          0 :         if (!this-&gt;parentNodes.empty()) {</span></a>
<a name="242"><span class="lineNum">     242 </span><span class="lineNoCov">          0 :           this-&gt;hiddingSomething = false;</span></a>
<a name="243"><span class="lineNum">     243 </span><span class="lineNoCov">          0 :           Node *node = this;</span></a>
<a name="244"><span class="lineNum">     244 </span><span class="lineNoCov">          0 :           std::stack&lt;Node *&gt; stek;</span></a>
<a name="245"><span class="lineNum">     245 </span><span class="lineNoCov">          0 :           bool begining = true;</span></a>
<a name="246"><span class="lineNum">     246 </span><span class="lineNoCov">          0 :           while (!node-&gt;parentNodes.empty() || !stek.empty() ||</span></a>
<a name="247"><span class="lineNum">     247 </span><span class="lineNoCov">          0 :                  begining == true) {</span></a>
<a name="248"><span class="lineNum">     248 </span><span class="lineNoCov">          0 :             begining = false;</span></a>
<a name="249"><span class="lineNum">     249 </span><span class="lineNoCov">          0 :             int childNum = node-&gt;parentNodes.size();</span></a>
<a name="250"><span class="lineNum">     250 </span><span class="lineNoCov">          0 :             int i = 0;</span></a>
<a name="251"><span class="lineNum">     251 </span><span class="lineNoCov">          0 :             for (; i &lt; childNum; i++) {</span></a>
<a name="252"><span class="lineNum">     252 </span>            : </a>
<a name="253"><span class="lineNum">     253 </span><span class="lineNoCov">          0 :               if (node-&gt;parentNodes[i]-&gt;getVisitedHide() == false) {</span></a>
<a name="254"><span class="lineNum">     254 </span><span class="lineNoCov">          0 :                 node-&gt;parentNodes[i]-&gt;setVisitedHide(true);</span></a>
<a name="255"><span class="lineNum">     255 </span><span class="lineNoCov">          0 :                 node-&gt;parentNodes[i]-&gt;isHidden = false;</span></a>
<a name="256"><span class="lineNum">     256 </span><span class="lineNoCov">          0 :                 node-&gt;parentNodes[i]-&gt;show();</span></a>
<a name="257"><span class="lineNum">     257 </span>            : </a>
<a name="258"><span class="lineNum">     258 </span><span class="lineNoCov">          0 :                 stek.push(node-&gt;parentNodes[i]);</span></a>
<a name="259"><span class="lineNum">     259 </span>            :               }</a>
<a name="260"><span class="lineNum">     260 </span>            :             }</a>
<a name="261"><span class="lineNum">     261 </span><span class="lineNoCov">          0 :             node = stek.top();</span></a>
<a name="262"><span class="lineNum">     262 </span><span class="lineNoCov">          0 :             stek.pop();</span></a>
<a name="263"><span class="lineNum">     263 </span><span class="lineNoCov">          0 :             node-&gt;setVisitedHide(false);</span></a>
<a name="264"><span class="lineNum">     264 </span><span class="lineNoCov">          0 :             node-&gt;show();</span></a>
<a name="265"><span class="lineNum">     265 </span>            :           }</a>
<a name="266"><span class="lineNum">     266 </span><span class="lineNoCov">          0 :           this-&gt;setGraphicsEffect(nullptr);</span></a>
<a name="267"><span class="lineNum">     267 </span>            :         }</a>
<a name="268"><span class="lineNum">     268 </span>            :       }</a>
<a name="269"><span class="lineNum">     269 </span>            :     }</a>
<a name="270"><span class="lineNum">     270 </span>            :   }</a>
<a name="271"><span class="lineNum">     271 </span><span class="lineNoCov">          0 :   QFrame::mousePressEvent(event);</span></a>
<a name="272"><span class="lineNum">     272 </span><span class="lineNoCov">          0 : }</span></a>
<a name="273"><span class="lineNum">     273 </span>            : </a>
<a name="274"><span class="lineNum">     274 </span><span class="lineCov">          2 : void Node::applyColors() {</span></a>
<a name="275"><span class="lineNum">     275 </span>            :   int i;</a>
<a name="276"><span class="lineNum">     276 </span><span class="lineCov">          3 :   for (i = 0; i &lt; inputs.size(); i++)</span></a>
<a name="277"><span class="lineNum">     277 </span><span class="lineCov">          1 :     inputs[i]-&gt;setStyleSheet(colors[inputTypes[i]]);</span></a>
<a name="278"><span class="lineNum">     278 </span><span class="lineCov">          3 :   for (i = 0; i &lt; outputs.size(); i++)</span></a>
<a name="279"><span class="lineNum">     279 </span><span class="lineCov">          1 :     outputs[i]-&gt;setStyleSheet(colors[outputTypes[i]]);</span></a>
<a name="280"><span class="lineNum">     280 </span><span class="lineCov">          2 : }</span></a>
<a name="281"><span class="lineNum">     281 </span>            : </a>
<a name="282"><span class="lineNum">     282 </span><span class="lineCov">          2 : void Node::setColors(QVector&lt;QChar&gt; v) {</span></a>
<a name="283"><span class="lineNum">     283 </span><span class="lineCov">          2 :   int i = 0;</span></a>
<a name="284"><span class="lineNum">     284 </span><span class="lineCov">          3 :   for (; i &lt; inputs.size(); i++) {</span></a>
<a name="285"><span class="lineNum">     285 </span><span class="lineCov">          1 :     inputTypes.push_back(v[i]);</span></a>
<a name="286"><span class="lineNum">     286 </span><span class="lineCov">          1 :     inputs[i]-&gt;setColor(v[i]);</span></a>
<a name="287"><span class="lineNum">     287 </span>            :   }</a>
<a name="288"><span class="lineNum">     288 </span><span class="lineCov">          2 :   int n = i;</span></a>
<a name="289"><span class="lineNum">     289 </span><span class="lineCov">          3 :   for (i = 0; i &lt; outputs.size(); i++) {</span></a>
<a name="290"><span class="lineNum">     290 </span><span class="lineCov">          1 :     outputTypes.push_back(v[n + i]);</span></a>
<a name="291"><span class="lineNum">     291 </span><span class="lineCov">          1 :     outputs[i]-&gt;setColor(v[n + i]);</span></a>
<a name="292"><span class="lineNum">     292 </span>            :   }</a>
<a name="293"><span class="lineNum">     293 </span><span class="lineCov">          2 :   applyColors();</span></a>
<a name="294"><span class="lineNum">     294 </span><span class="lineCov">          2 : }</span></a>
<a name="295"><span class="lineNum">     295 </span>            : </a>
<a name="296"><span class="lineNum">     296 </span><span class="lineNoCov">          0 : auto Node::getColors() -&gt; QMap&lt;QChar, QString&gt; { return colors; }</span></a>
<a name="297"><span class="lineNum">     297 </span>            : </a>
<a name="298"><span class="lineNum">     298 </span><span class="lineNoCov">          0 : auto Node::getVarName() const -&gt; QString { return &quot;&quot;; }</span></a>
<a name="299"><span class="lineNum">     299 </span>            : </a>
<a name="300"><span class="lineNum">     300 </span><span class="lineCov">          2 : void Node::setNodeId(QString nodeId) { this-&gt;nodeId = nodeId; }</span></a>
<a name="301"><span class="lineNum">     301 </span>            : </a>
<a name="302"><span class="lineNum">     302 </span><span class="lineNoCov">          0 : void Node::setVisitedHide(bool flag) { this-&gt;visitedHide = flag; }</span></a>
<a name="303"><span class="lineNum">     303 </span>            : </a>
<a name="304"><span class="lineNum">     304 </span><span class="lineNoCov">          0 : void Node::addParents(Node *parent) { this-&gt;parentNodes.push_back(parent); }</span></a>
<a name="305"><span class="lineNum">     305 </span>            : </a>
<a name="306"><span class="lineNum">     306 </span><span class="lineNoCov">          0 : void Node::addChildren(Node *child) { this-&gt;childNodes.push_back(child); }</span></a>
<a name="307"><span class="lineNum">     307 </span>            : </a>
<a name="308"><span class="lineNum">     308 </span><span class="lineNoCov">          0 : auto Node::getChildren() -&gt; QVector&lt;Node *&gt; &amp; { return this-&gt;childNodes; }</span></a>
<a name="309"><span class="lineNum">     309 </span>            : </a>
<a name="310"><span class="lineNum">     310 </span><span class="lineNoCov">          0 : auto Node::getParents() -&gt; QVector&lt;Node *&gt; &amp; { return this-&gt;parentNodes; }</span></a>
<a name="311"><span class="lineNum">     311 </span>            : </a>
<a name="312"><span class="lineNum">     312 </span><span class="lineCov">       9180 : auto Node::getOldPos() -&gt; QPoint * { return &amp;oldPos_; }</span></a>
<a name="313"><span class="lineNum">     313 </span><span class="lineCov">          1 : void Node::setOldPos(QPoint p) { oldPos_ = p; }</span></a>
<a name="314"><span class="lineNum">     314 </span>            : </a>
<a name="315"><span class="lineNum">     315 </span><span class="lineNoCov">          0 : auto Node::getOldPosCopy() -&gt; QPoint * { return &amp;oldPosCopy; }</span></a>
<a name="316"><span class="lineNum">     316 </span><span class="lineNoCov">          0 : void Node::setOldPosCopy(QPoint p) { this-&gt;oldPosCopy = p; }</span></a>
<a name="317"><span class="lineNum">     317 </span>            : </a>
<a name="318"><span class="lineNum">     318 </span><span class="lineCov">       9174 : auto Node::getInputs() -&gt; QVector&lt;Input *&gt; * { return &amp;(this-&gt;inputs); }</span></a>
<a name="319"><span class="lineNum">     319 </span><span class="lineNoCov">          0 : auto Node::getOutputs() -&gt; QVector&lt;Output *&gt; * { return &amp;(this-&gt;outputs); }</span></a>
<a name="320"><span class="lineNum">     320 </span>            : </a>
<a name="321"><span class="lineNum">     321 </span><span class="lineNoCov">          0 : auto Node::getCodeForNode() -&gt; QString { return code; }</span></a>
<a name="322"><span class="lineNum">     322 </span>            : </a>
<a name="323"><span class="lineNum">     323 </span><span class="lineNoCov">          0 : auto Node::getNodeId() -&gt; QString { return this-&gt;nodeId; }</span></a>
<a name="324"><span class="lineNum">     324 </span>            : </a>
<a name="325"><span class="lineNum">     325 </span><span class="lineNoCov">          0 : void Node::setVisited(bool flag) { this-&gt;visited = flag; }</span></a>
<a name="326"><span class="lineNum">     326 </span>            : </a>
<a name="327"><span class="lineNum">     327 </span><span class="lineNoCov">          0 : auto Node::getVisited() -&gt; bool { return this-&gt;visited; }</span></a>
<a name="328"><span class="lineNum">     328 </span>            : </a>
<a name="329"><span class="lineNum">     329 </span><span class="lineNoCov">          0 : auto Node::getVisitedHide() -&gt; bool { return this-&gt;visitedHide; }</span></a>
<a name="330"><span class="lineNum">     330 </span>            : </a>
<a name="331"><span class="lineNum">     331 </span><span class="lineNoCov">          0 : auto Node::getName() -&gt; QString { return this-&gt;name; }</span></a>
<a name="332"><span class="lineNum">     332 </span>            : </a>
<a name="333"><span class="lineNum">     333 </span><span class="lineNoCov">          0 : auto Node::getParentNodes() -&gt; QVector&lt;Node *&gt; { return parentNodes; }</span></a>
</pre>
      </td>
    </tr>
  </table>
  <br>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="ruler"><img src="../../../../../../glass.png" width=3 height=3 alt=""></td></tr>
    <tr><td class="versionInfo">Generated by: <a href="http://ltp.sourceforge.net/coverage/lcov.php" target="_parent">LCOV version 1.14</a></td></tr>
  </table>
  <br>

</body>
</html>
